Commits

myuhe  committed c6a5d2e

C-gでdmenuを抜けられるようにした

  • Participants

Comments (0)

Files changed (15)

+MIT/X Consortium License
+
+© 2010 Connor Lane Smith <cls@lubutu.com>
+© 2006-2010 Anselm R Garbe <anselm@garbe.us>
+© 2009 Gottox <gottox@s01.de>
+© 2009 Markus Schnalke <meillo@marmaro.de>
+© 2009 Evan Gates <evan.gates@gmail.com>
+© 2006-2008 Sander van Dijk <a dot h dot vandijk at gmail dot com>
+© 2006-2007 Michał Janeczek <janeczek at gmail dot com>
+
+Permission is hereby granted, free of charge, to any person obtaining a
+copy of this software and associated documentation files (the "Software"),
+to deal in the Software without restriction, including without limitation
+the rights to use, copy, modify, merge, publish, distribute, sublicense,
+and/or sell copies of the Software, and to permit persons to whom the
+Software is furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in
+all copies or substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+DEALINGS IN THE SOFTWARE.
+# dmenu - dynamic menu
+# See LICENSE file for copyright and license details.
+
+include config.mk
+
+all: options dmenu dmenu_path
+
+options:
+	@echo dmenu build options:
+	@echo "CFLAGS   = ${CFLAGS}"
+	@echo "LDFLAGS  = ${LDFLAGS}"
+	@echo "CC       = ${CC}"
+
+dmenu: dmenu.o draw.o
+dmenu_path: dmenu_path.o
+
+.c.o: config.mk
+	@echo CC -c $<
+	@${CC} -c $< ${CFLAGS}
+
+dmenu dmenu_path:
+	@echo CC -o $@
+	@${CC} -o $@ $+ ${LDFLAGS}
+
+clean:
+	@echo cleaning
+	@rm -f dmenu dmenu.o draw.o dmenu_path dmenu_path.o dmenu-${VERSION}.tar.gz
+
+dist: clean
+	@echo creating dist tarball
+	@mkdir -p dmenu-${VERSION}
+	@cp LICENSE Makefile README config.mk dmenu.1 dmenu.c draw.c draw.h dmenu_path.c dmenu_run dmenu-${VERSION}
+	@tar -cf dmenu-${VERSION}.tar dmenu-${VERSION}
+	@gzip dmenu-${VERSION}.tar
+	@rm -rf dmenu-${VERSION}
+
+install: all
+	@echo installing executables to ${DESTDIR}${PREFIX}/bin
+	@mkdir -p ${DESTDIR}${PREFIX}/bin
+	@cp -f dmenu dmenu_path dmenu_run ${DESTDIR}${PREFIX}/bin
+	@chmod 755 ${DESTDIR}${PREFIX}/bin/dmenu
+	@chmod 755 ${DESTDIR}${PREFIX}/bin/dmenu_path
+	@chmod 755 ${DESTDIR}${PREFIX}/bin/dmenu_run
+	@echo installing manual page to ${DESTDIR}${MANPREFIX}/man1
+	@mkdir -p ${DESTDIR}${MANPREFIX}/man1
+	@sed "s/VERSION/${VERSION}/g" < dmenu.1 > ${DESTDIR}${MANPREFIX}/man1/dmenu.1
+	@chmod 644 ${DESTDIR}${MANPREFIX}/man1/dmenu.1
+
+uninstall:
+	@echo removing executables from ${DESTDIR}${PREFIX}/bin
+	@rm -f ${DESTDIR}${PREFIX}/bin/dmenu
+	@rm -f ${DESTDIR}${PREFIX}/bin/dmenu_path
+	@rm -f ${DESTDIR}${PREFIX}/bin/dmenu_run
+	@echo removing manual page from ${DESTDIR}${MANPREFIX}/man1
+	@rm -f ${DESTDIR}${MANPREFIX}/man1/dmenu.1
+
+.PHONY: all options clean dist install uninstall
+dmenu - dynamic menu
+====================
+dmenu is an efficient dynamic menu for X.
+
+
+Requirements
+------------
+In order to build dmenu you need the Xlib header files.
+
+
+Installation
+------------
+Edit config.mk to match your local setup (dmenu is installed into
+the /usr/local namespace by default).
+
+Afterwards enter the following command to build and install dmenu
+(if necessary as root):
+
+    make clean install
+
+
+Running dmenu
+-------------
+See the man page for details.
+# dmenu version
+VERSION = 4.2.1
+
+# Customize below to fit your system
+
+# paths
+PREFIX = /usr/local
+MANPREFIX = ${PREFIX}/share/man
+
+X11INC = /usr/X11R6/include
+X11LIB = /usr/X11R6/lib
+
+# Xinerama, comment if you don't want it
+XINERAMALIBS  = -lXinerama
+XINERAMAFLAGS = -DXINERAMA
+
+# includes and libs
+INCS = -I${X11INC}
+LIBS = -L${X11LIB} -lX11 ${XINERAMALIBS}
+
+# flags
+CPPFLAGS = -D_BSD_SOURCE -DVERSION=\"${VERSION}\" ${XINERAMAFLAGS}
+CFLAGS   = -std=c99 -pedantic -Wall -Os ${INCS} ${CPPFLAGS}
+LDFLAGS  = -s ${LIBS}
+
+# compiler and linker
+CC = cc

File dmenu

Binary file added.
+.TH DMENU 1 dmenu\-VERSION
+.SH NAME
+dmenu \- dynamic menu
+.SH SYNOPSIS
+.B dmenu
+.RB [ \-b ]
+.RB [ \-i ]
+.RB [ \-l
+.IR lines ]
+.RB [ \-m
+.IR monitor ]
+.RB [ \-p
+.IR prompt ]
+.RB [ \-fn
+.IR font ]
+.RB [ \-nb
+.IR color ]
+.RB [ \-nf
+.IR color ]
+.RB [ \-sb
+.IR color ]
+.RB [ \-sf
+.IR color ]
+.RB [ \-v ]
+.P
+.BR dmenu_run " ..."
+.P
+.B dmenu_path
+.SH DESCRIPTION
+.B dmenu
+is a dynamic menu for X, originally designed for
+.BR dwm (1).
+It manages huge numbers of user-defined menu items efficiently.
+.P
+dmenu reads a list of newline-separated items from standard input and creates a
+menu.  When the user selects an item or enters any text and presses Return,
+their choice is printed to standard output and dmenu terminates.
+.P
+.B dmenu_run
+is a dmenu script used by dwm which lists programs in the user's PATH and
+executes the selected item.
+.P
+.B dmenu_path
+is a program used by dmenu_run to find and cache a list of executables.
+.SH OPTIONS
+.TP
+.B \-b
+dmenu appears at the bottom of the screen.
+.TP
+.B \-i
+dmenu matches menu items case insensitively.
+.TP
+.BI \-l " lines"
+dmenu lists items vertically, with the given number of lines.
+.TP
+.BI \-m " monitor"
+dmenu appears on the given Xinerama screen.
+.TP
+.BI \-p " prompt"
+defines the prompt to be displayed to the left of the input field.
+.TP
+.BI \-fn " font"
+defines the font or font set used.
+.TP
+.BI \-nb " color"
+defines the normal background color.
+.IR #RGB ,
+.IR #RRGGBB ,
+and color names are supported.
+.TP
+.BI \-nf " color"
+defines the normal foreground color.
+.TP
+.BI \-sb " color"
+defines the selected background color.
+.TP
+.BI \-sf " color"
+defines the selected foreground color.
+.TP
+.B \-v
+prints version information to standard output, then exits.
+.SH USAGE
+dmenu is completely controlled by the keyboard.  Besides standard Unix line
+editing and item selection (Up/Down/Left/Right, PageUp/PageDown, Home/End), the
+following keys are recognized:
+.TP
+.B Tab (Control\-i)
+Copy the selected item to the input field.
+.TP
+.B Return (Control\-j)
+Confirm selection.  Prints the selected item to standard output and exits,
+returning success.
+.TP
+.B Shift\-Return (Control\-Shift\-j)
+Confirm input.  Prints the input text to standard output and exits, returning
+success.
+.TP
+.B Escape (Control\-c)
+Exit without selecting an item, returning failure.
+.TP
+.B Control\-y
+Paste the current X selection into the input field.
+.SH SEE ALSO
+.BR dwm (1)
+/* See LICENSE file for copyright and license details. */
+#include <ctype.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <X11/Xlib.h>
+#include <X11/Xatom.h>
+#include <X11/Xutil.h>
+#ifdef XINERAMA
+#include <X11/extensions/Xinerama.h>
+#endif
+#include "draw.h"
+
+#define INRECT(x,y,rx,ry,rw,rh) ((x) >= (rx) && (x) < (rx)+(rw) && (y) >= (ry) && (y) < (ry)+(rh))
+#define MIN(a,b)                ((a) < (b) ? (a) : (b))
+#define MAX(a,b)                ((a) > (b) ? (a) : (b))
+
+typedef struct Item Item;
+struct Item {
+	char *text;
+	Item *next;          /* traverses all items */
+	Item *left, *right;  /* traverses matching items */
+};
+
+static void appenditem(Item *item, Item **list, Item **last);
+static void calcoffsets(void);
+static void drawmenu(void);
+static char *fstrstr(const char *s, const char *sub);
+static void grabkeyboard(void);
+static void insert(const char *s, ssize_t n);
+static void keypress(XKeyEvent *ev);
+static void match(void);
+static size_t nextrune(int incr);
+static void paste(void);
+static void readstdin(void);
+static void run(void);
+static void setup(void);
+static void usage(void);
+
+static char text[BUFSIZ];
+static int bh, mw, mh;
+static int inputw = 0;
+static int lines = 0;
+static int monitor = -1;
+static int promptw;
+static size_t cursor = 0;
+static const char *font = NULL;
+static const char *prompt = NULL;
+static const char *normbgcolor = "#cccccc";
+static const char *normfgcolor = "#000000";
+static const char *selbgcolor  = "#0066ff";
+static const char *selfgcolor  = "#ffffff";
+static unsigned long normcol[ColLast];
+static unsigned long selcol[ColLast];
+static Atom utf8;
+static Bool topbar = True;
+static DC *dc;
+static Item *items = NULL;
+static Item *matches, *sel;
+static Item *prev, *curr, *next;
+static Window root, win;
+
+static int (*fstrncmp)(const char *, const char *, size_t) = strncmp;
+
+int
+main(int argc, char *argv[]) {
+	int i;
+
+	progname = "dmenu";
+	for(i = 1; i < argc; i++)
+		/* single flags */
+		if(!strcmp(argv[i], "-v")) {
+			fputs("dmenu-"VERSION", © 2006-2010 dmenu engineers, see LICENSE for details\n", stdout);
+			exit(EXIT_SUCCESS);
+		}
+		else if(!strcmp(argv[i], "-b"))
+			topbar = False;
+		else if(!strcmp(argv[i], "-i"))
+			fstrncmp = strncasecmp;
+		else if(i == argc-1)
+			usage();
+		/* double flags */
+		else if(!strcmp(argv[i], "-l"))
+			lines = atoi(argv[++i]);
+		else if(!strcmp(argv[i], "-m"))
+			monitor = atoi(argv[++i]);
+		else if(!strcmp(argv[i], "-p"))
+			prompt = argv[++i];
+		else if(!strcmp(argv[i], "-fn"))
+			font = argv[++i];
+		else if(!strcmp(argv[i], "-nb"))
+			normbgcolor = argv[++i];
+		else if(!strcmp(argv[i], "-nf"))
+			normfgcolor = argv[++i];
+		else if(!strcmp(argv[i], "-sb"))
+			selbgcolor = argv[++i];
+		else if(!strcmp(argv[i], "-sf"))
+			selfgcolor = argv[++i];
+		else
+			usage();
+
+	dc = initdc();
+	initfont(dc, font);
+	readstdin();
+	setup();
+	run();
+
+	return EXIT_FAILURE;  /* should not reach */
+}
+
+void
+appenditem(Item *item, Item **list, Item **last) {
+	if(!*last)
+		*list = item;
+	else
+		(*last)->right = item;
+	item->left = *last;
+	item->right = NULL;
+	*last = item;
+}
+
+void
+calcoffsets(void) {
+	unsigned int i, n;
+
+	if(lines > 0)
+		n = lines * bh;
+	else
+		n = mw - (promptw + inputw + textw(dc, "<") + textw(dc, ">"));
+
+	for(i = 0, next = curr; next; next = next->right)
+		if((i += (lines > 0) ? bh : MIN(textw(dc, next->text), n)) > n)
+			break;
+	for(i = 0, prev = curr; prev && prev->left; prev = prev->left)
+		if((i += (lines > 0) ? bh : MIN(textw(dc, prev->left->text), n)) > n)
+			break;
+}
+
+void
+drawmenu(void) {
+	int curpos;
+	Item *item;
+
+	dc->x = 0;
+	dc->y = 0;
+	dc->h = bh;
+	drawrect(dc, 0, 0, mw, mh, True, BG(dc, normcol));
+
+	if(prompt) {
+		dc->w = promptw;
+		drawtext(dc, prompt, selcol);
+		dc->x = dc->w;
+	}
+	dc->w = (lines > 0 || !matches) ? mw - dc->x : inputw;
+	drawtext(dc, text, normcol);
+	if((curpos = textnw(dc, text, cursor) + dc->h/2 - 2) < dc->w)
+		drawrect(dc, curpos, 2, 1, dc->h - 4, True, FG(dc, normcol));
+
+	if(lines > 0) {
+		dc->w = mw - dc->x;
+		for(item = curr; item != next; item = item->right) {
+			dc->y += dc->h;
+			drawtext(dc, item->text, (item == sel) ? selcol : normcol);
+		}
+	}
+	else if(matches) {
+		dc->x += inputw;
+		dc->w = textw(dc, "<");
+		if(curr->left)
+			drawtext(dc, "<", normcol);
+		for(item = curr; item != next; item = item->right) {
+			dc->x += dc->w;
+			dc->w = MIN(textw(dc, item->text), mw - dc->x - textw(dc, ">"));
+			drawtext(dc, item->text, (item == sel) ? selcol : normcol);
+		}
+		dc->w = textw(dc, ">");
+		dc->x = mw - dc->w;
+		if(next)
+			drawtext(dc, ">", normcol);
+	}
+	mapdc(dc, win, mw, mh);
+}
+
+char *
+fstrstr(const char *s, const char *sub) {
+	size_t len;
+
+	for(len = strlen(sub); *s; s++)
+		if(!fstrncmp(s, sub, len))
+			return (char *)s;
+	return NULL;
+}
+
+void
+grabkeyboard(void) {
+	int i;
+
+	for(i = 0; i < 1000; i++) {
+		if(!XGrabKeyboard(dc->dpy, root, True, GrabModeAsync, GrabModeAsync, CurrentTime))
+			return;
+		usleep(1000);
+	}
+	eprintf("cannot grab keyboard\n");
+}
+
+void
+insert(const char *s, ssize_t n) {
+	if(strlen(text) + n > sizeof text - 1)
+		return;
+	memmove(text + cursor + n, text + cursor, sizeof text - cursor - MAX(n, 0));
+	if(n > 0)
+		memcpy(text + cursor, s, n);
+	cursor += n;
+	match();
+}
+
+void
+keypress(XKeyEvent *ev) {
+	char buf[32];
+	size_t len;
+	KeySym ksym;
+
+	len = strlen(text);
+	XLookupString(ev, buf, sizeof buf, &ksym, NULL);
+	if(ev->state & ControlMask) {
+		switch(tolower(ksym)) {
+		default:
+			return;
+		case XK_a:
+			ksym = XK_Home;
+			break;
+		case XK_b:
+			ksym = XK_Left;
+			break;
+		case XK_c:
+			ksym = XK_Escape;
+			break;
+		case XK_d:
+			ksym = XK_Delete;
+			break;
+		case XK_e:
+			ksym = XK_End;
+			break;
+		case XK_f:
+			ksym = XK_Right;
+			break;
+                case XK_g:
+                        ksym = XK_Escape;
+                        break;
+		case XK_h:
+			ksym = XK_BackSpace;
+			break;
+		case XK_i:
+			ksym = XK_Tab;
+			break;
+		case XK_j:
+			ksym = XK_Return;
+			break;
+		case XK_k:  /* delete right */
+			text[cursor] = '\0';
+			match();
+			break;
+		case XK_n:
+			ksym = XK_Down;
+			break;
+		case XK_p:
+			ksym = XK_Up;
+			break;
+		case XK_u:  /* delete left */
+			insert(NULL, 0 - cursor);
+			break;
+		case XK_w:  /* delete word */
+			while(cursor > 0 && text[nextrune(-1)] == ' ')
+				insert(NULL, nextrune(-1) - cursor);
+			while(cursor > 0 && text[nextrune(-1)] != ' ')
+				insert(NULL, nextrune(-1) - cursor);
+			break;
+		case XK_y:  /* paste selection */
+			XConvertSelection(dc->dpy, XA_PRIMARY, utf8, utf8, win, CurrentTime);
+			return;
+		}
+	}
+	switch(ksym) {
+	default:
+		if(!iscntrl(*buf))
+			insert(buf, strlen(buf));
+		break;
+	case XK_Delete:
+		if(cursor == len)
+			return;
+		cursor = nextrune(+1);
+	case XK_BackSpace:
+		if(cursor > 0)
+			insert(NULL, nextrune(-1) - cursor);
+		break;
+	case XK_End:
+		if(cursor < len) {
+			cursor = len;
+			break;
+		}
+		while(next) {
+			sel = curr = next;
+			calcoffsets();
+		}
+		while(sel && sel->right)
+			sel = sel->right;
+		break;
+	case XK_Escape:
+		exit(EXIT_FAILURE);
+	case XK_Home:
+		if(sel == matches) {
+			cursor = 0;
+			break;
+		}
+		sel = curr = matches;
+		calcoffsets();
+		break;
+	case XK_Left:
+		if(cursor > 0 && (!sel || !sel->left || lines > 0)) {
+			cursor = nextrune(-1);
+			break;
+		}
+		else if(lines > 0)
+			return;
+	case XK_Up:
+		if(sel && sel->left && (sel = sel->left)->right == curr) {
+			curr = prev;
+			calcoffsets();
+		}
+		break;
+	case XK_Next:
+		if(!next)
+			return;
+		sel = curr = next;
+		calcoffsets();
+		break;
+	case XK_Prior:
+		if(!prev)
+			return;
+		sel = curr = prev;
+		calcoffsets();
+		break;
+	case XK_Return:
+	case XK_KP_Enter:
+		fputs((sel && !(ev->state & ShiftMask)) ? sel->text : text, stdout);
+		fflush(stdout);
+		exit(EXIT_SUCCESS);
+	case XK_Right:
+		if(cursor < len) {
+			cursor = nextrune(+1);
+			break;
+		}
+		else if(lines > 0)
+			return;
+	case XK_Down:
+		if(sel && sel->right && (sel = sel->right) == next) {
+			curr = next;
+			calcoffsets();
+		}
+		break;
+	case XK_Tab:
+		if(!sel)
+			return;
+		strncpy(text, sel->text, sizeof text);
+		cursor = strlen(text);
+		match();
+		break;
+	}
+	drawmenu();
+}
+
+void
+match(void) {
+	size_t len;
+	Item *item, *itemend, *lexact, *lprefix, *lsubstr, *exactend, *prefixend, *substrend;
+
+	len = strlen(text);
+	matches = lexact = lprefix = lsubstr = itemend = exactend = prefixend = substrend = NULL;
+	for(item = items; item; item = item->next)
+		if(!fstrncmp(text, item->text, len + 1))
+			appenditem(item, &lexact, &exactend);
+		else if(!fstrncmp(text, item->text, len))
+			appenditem(item, &lprefix, &prefixend);
+		else if(fstrstr(item->text, text))
+			appenditem(item, &lsubstr, &substrend);
+
+	if(lexact) {
+		matches = lexact;
+		itemend = exactend;
+	}
+	if(lprefix) {
+		if(itemend) {
+			itemend->right = lprefix;
+			lprefix->left = itemend;
+		}
+		else
+			matches = lprefix;
+		itemend = prefixend;
+	}
+	if(lsubstr) {
+		if(itemend) {
+			itemend->right = lsubstr;
+			lsubstr->left = itemend;
+		}
+		else
+			matches = lsubstr;
+	}
+	curr = prev = next = sel = matches;
+	calcoffsets();
+}
+
+size_t
+nextrune(int incr) {
+	size_t n, len;
+
+	len = strlen(text);
+	for(n = cursor + incr; n >= 0 && n < len && (text[n] & 0xc0) == 0x80; n += incr);
+	return n;
+}
+
+void
+paste(void) {
+	char *p, *q;
+	int di;
+	unsigned long dl;
+	Atom da;
+
+	XGetWindowProperty(dc->dpy, win, utf8, 0, (sizeof text / 4) + 1, False,
+	                   utf8, &da, &di, &dl, &dl, (unsigned char **)&p);
+	insert(p, (q = strchr(p, '\n')) ? q-p : strlen(p));
+	XFree(p);
+	drawmenu();
+}
+
+void
+readstdin(void) {
+	char buf[sizeof text], *p;
+	Item *item, **end;
+
+	for(end = &items; fgets(buf, sizeof buf, stdin); *end = item, end = &item->next) {
+		if((p = strchr(buf, '\n')))
+			*p = '\0';
+		if(!(item = malloc(sizeof *item)))
+			eprintf("cannot malloc %u bytes\n", sizeof *item);
+		if(!(item->text = strdup(buf)))
+			eprintf("cannot strdup %u bytes\n", strlen(buf)+1);
+		item->next = item->left = item->right = NULL;
+		inputw = MAX(inputw, textw(dc, item->text));
+	}
+}
+
+void
+run(void) {
+	XEvent ev;
+
+	while(!XNextEvent(dc->dpy, &ev))
+		switch(ev.type) {
+		case Expose:
+			if(ev.xexpose.count == 0)
+				drawmenu();
+			break;
+		case KeyPress:
+			keypress(&ev.xkey);
+			break;
+		case SelectionNotify:
+			if(ev.xselection.property == utf8)
+				paste();
+			break;
+		case VisibilityNotify:
+			if(ev.xvisibility.state != VisibilityUnobscured)
+				XRaiseWindow(dc->dpy, win);
+			break;
+		}
+}
+
+void
+setup(void) {
+	int x, y, screen;
+	XSetWindowAttributes wa;
+#ifdef XINERAMA
+	int n;
+	XineramaScreenInfo *info;
+#endif
+
+	screen = DefaultScreen(dc->dpy);
+	root = RootWindow(dc->dpy, screen);
+	utf8 = XInternAtom(dc->dpy, "UTF8_STRING", False);
+
+	normcol[ColBG] = getcolor(dc, normbgcolor);
+	normcol[ColFG] = getcolor(dc, normfgcolor);
+	selcol[ColBG] = getcolor(dc, selbgcolor);
+	selcol[ColFG] = getcolor(dc, selfgcolor);
+
+	/* menu geometry */
+	bh = dc->font.height + 2;
+	lines = MAX(lines, 0);
+	mh = (lines + 1) * bh;
+#ifdef XINERAMA
+	if((info = XineramaQueryScreens(dc->dpy, &n))) {
+		int i, di;
+		unsigned int du;
+		Window dw;
+
+		XQueryPointer(dc->dpy, root, &dw, &dw, &x, &y, &di, &di, &du);
+		for(i = 0; i < n; i++)
+			if((monitor == info[i].screen_number)
+			|| (monitor < 0 && INRECT(x, y, info[i].x_org, info[i].y_org, info[i].width, info[i].height)))
+				break;
+		x = info[i].x_org;
+		y = info[i].y_org + (topbar ? 0 : info[i].height - mh);
+		mw = info[i].width;
+		XFree(info);
+	}
+	else
+#endif
+	{
+		x = 0;
+		y = topbar ? 0 : DisplayHeight(dc->dpy, screen) - mh;
+		mw = DisplayWidth(dc->dpy, screen);
+	}
+	/* menu window */
+	wa.override_redirect = True;
+	wa.background_pixmap = ParentRelative;
+	wa.event_mask = ExposureMask | KeyPressMask | VisibilityChangeMask;
+	win = XCreateWindow(dc->dpy, root, x, y, mw, mh, 0,
+	                    DefaultDepth(dc->dpy, screen), CopyFromParent,
+	                    DefaultVisual(dc->dpy, screen),
+	                    CWOverrideRedirect | CWBackPixmap | CWEventMask, &wa);
+
+	grabkeyboard();
+	resizedc(dc, mw, mh);
+	inputw = MIN(inputw, mw/3);
+	promptw = prompt ? textw(dc, prompt) : 0;
+	XMapRaised(dc->dpy, win);
+	text[0] = '\0';
+	match();
+}
+
+void
+usage(void) {
+	fputs("usage: dmenu [-b] [-i] [-l lines] [-m monitor] [-p prompt] [-fn font]\n"
+	      "             [-nb color] [-nf color] [-sb color] [-sf color] [-v]\n", stderr);
+	exit(EXIT_FAILURE);
+}

File dmenu.o

Binary file added.

File dmenu_path

Binary file added.

File dmenu_path.c

+/* See LICENSE file for copyright and license details. */
+#include <dirent.h>
+#include <limits.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <sys/stat.h>
+
+#define CACHE ".dmenu_cache"
+
+static void die(const char *s);
+static int qstrcmp(const void *a, const void *b);
+static void scan(void);
+static int uptodate(void);
+
+static char **items = NULL;
+static const char *home, *path;
+
+int
+main(void) {
+	if(!(home = getenv("HOME")))
+		die("no $HOME");
+	if(!(path = getenv("PATH")))
+		die("no $PATH");
+	if(chdir(home) < 0)
+		die("chdir failed");
+	if(uptodate()) {
+		execlp("cat", "cat", CACHE, NULL);
+		die("exec failed");
+	}
+	scan();
+	return EXIT_SUCCESS;
+}
+
+void
+die(const char *s) {
+	fprintf(stderr, "dmenu_path: %s\n", s);
+	exit(EXIT_FAILURE);
+}
+
+int
+qstrcmp(const void *a, const void *b) {
+	return strcmp(*(const char **)a, *(const char **)b);
+}
+
+void
+scan(void) {
+	char buf[PATH_MAX];
+	char *dir, *p;
+	size_t i, count;
+	struct dirent *ent;
+	DIR *dp;
+	FILE *cache;
+
+	count = 0;
+	if(!(p = strdup(path)))
+		die("strdup failed");
+	for(dir = strtok(p, ":"); dir; dir = strtok(NULL, ":")) {
+		if(!(dp = opendir(dir)))
+			continue;
+		while((ent = readdir(dp))) {
+			snprintf(buf, sizeof buf, "%s/%s", dir, ent->d_name);
+			if(ent->d_name[0] == '.' || access(buf, X_OK) < 0)
+				continue;
+			if(!(items = realloc(items, ++count * sizeof *items)))
+				die("malloc failed");
+			if(!(items[count-1] = strdup(ent->d_name)))
+				die("strdup failed");
+		}
+		closedir(dp);
+	}
+	qsort(items, count, sizeof *items, qstrcmp);
+	if(!(cache = fopen(CACHE, "w")))
+		die("open failed");
+	for(i = 0; i < count; i++) {
+		if(i > 0 && !strcmp(items[i], items[i-1]))
+			continue;
+		fprintf(cache,  "%s\n", items[i]);
+		fprintf(stdout, "%s\n", items[i]);
+	}
+	fclose(cache);
+	free(p);
+}
+
+int
+uptodate(void) {
+	char *dir, *p;
+	time_t mtime;
+	struct stat st;
+
+	if(stat(CACHE, &st) < 0)
+		return 0;
+	mtime = st.st_mtime;
+	if(!(p = strdup(path)))
+		die("strdup failed");
+	for(dir = strtok(p, ":"); dir; dir = strtok(NULL, ":"))
+		if(!stat(dir, &st) && st.st_mtime > mtime)
+			return 0;
+	free(p);
+	return 1;
+}

File dmenu_path.o

Binary file added.
+#!/bin/sh
+exe=`dmenu_path | dmenu ${1+"$@"}` && exec $exe
+/* See LICENSE file for copyright and license details. */
+#include <locale.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <X11/Xlib.h>
+#include "draw.h"
+
+#define MAX(a, b)   ((a) > (b) ? (a) : (b))
+#define MIN(a, b)   ((a) < (b) ? (a) : (b))
+#define DEFFONT     "fixed"
+
+static Bool loadfont(DC *dc, const char *fontstr);
+
+void
+drawrect(DC *dc, int x, int y, unsigned int w, unsigned int h, Bool fill, unsigned long color) {
+	XRectangle r = { dc->x + x, dc->y + y, w, h };
+
+	if(!fill) {
+		r.width -= 1;
+		r.height -= 1;
+	}
+	XSetForeground(dc->dpy, dc->gc, color);
+	(fill ? XFillRectangles : XDrawRectangles)(dc->dpy, dc->canvas, dc->gc, &r, 1);
+}
+
+
+void
+drawtext(DC *dc, const char *text, unsigned long col[ColLast]) {
+	char buf[256];
+	size_t n, mn;
+
+	/* shorten text if necessary */
+	n = strlen(text);
+	for(mn = MIN(n, sizeof buf); textnw(dc, text, mn) > dc->w - dc->font.height/2; mn--)
+		if(mn == 0)
+			return;
+	memcpy(buf, text, mn);
+	if(mn < n)
+		for(n = MAX(mn-3, 0); n < mn; buf[n++] = '.');
+
+	drawrect(dc, 0, 0, dc->w, dc->h, True, BG(dc, col));
+	drawtextn(dc, buf, mn, col);
+}
+
+void
+drawtextn(DC *dc, const char *text, size_t n, unsigned long col[ColLast]) {
+	int x, y;
+
+	x = dc->x + dc->font.height/2;
+	y = dc->y + dc->font.ascent+1;
+
+	XSetForeground(dc->dpy, dc->gc, FG(dc, col));
+	if(dc->font.set)
+		XmbDrawString(dc->dpy, dc->canvas, dc->font.set, dc->gc, x, y, text, n);
+	else {
+		XSetFont(dc->dpy, dc->gc, dc->font.xfont->fid);
+		XDrawString(dc->dpy, dc->canvas, dc->gc, x, y, text, n);
+	}
+}
+
+void
+eprintf(const char *fmt, ...) {
+	va_list ap;
+
+	fprintf(stderr, "%s: ", progname);
+	va_start(ap, fmt);
+	vfprintf(stderr, fmt, ap);
+	va_end(ap);
+	exit(EXIT_FAILURE);
+}
+
+void
+freedc(DC *dc) {
+	if(dc->font.set)
+		XFreeFontSet(dc->dpy, dc->font.set);
+	if(dc->font.xfont)
+		XFreeFont(dc->dpy, dc->font.xfont);
+	if(dc->canvas)
+		XFreePixmap(dc->dpy, dc->canvas);
+	XFreeGC(dc->dpy, dc->gc);
+	XCloseDisplay(dc->dpy);
+	free(dc);
+}
+
+unsigned long
+getcolor(DC *dc, const char *colstr) {
+	Colormap cmap = DefaultColormap(dc->dpy, DefaultScreen(dc->dpy));
+	XColor color;
+
+	if(!XAllocNamedColor(dc->dpy, cmap, colstr, &color, &color))
+		eprintf("cannot allocate color '%s'\n", colstr);
+	return color.pixel;
+}
+
+DC *
+initdc(void) {
+	DC *dc;
+
+	if(!setlocale(LC_CTYPE, "") || !XSupportsLocale())
+		weprintf("no locale support\n");
+	if(!(dc = malloc(sizeof *dc)))
+		eprintf("cannot malloc %u bytes\n", sizeof *dc);
+	if(!(dc->dpy = XOpenDisplay(NULL)))
+		eprintf("cannot open display\n");
+
+	dc->gc = XCreateGC(dc->dpy, DefaultRootWindow(dc->dpy), 0, NULL);
+	XSetLineAttributes(dc->dpy, dc->gc, 1, LineSolid, CapButt, JoinMiter);
+	dc->font.xfont = NULL;
+	dc->font.set = NULL;
+	dc->canvas = None;
+	return dc;
+}
+
+void
+initfont(DC *dc, const char *fontstr) {
+	if(!loadfont(dc, fontstr ? fontstr : DEFFONT)) {
+		if(fontstr != NULL)
+			weprintf("cannot load font '%s'\n", fontstr);
+		if(fontstr == NULL || !loadfont(dc, DEFFONT))
+			eprintf("cannot load font '%s'\n", DEFFONT);
+	}
+	dc->font.height = dc->font.ascent + dc->font.descent;
+}
+
+Bool
+loadfont(DC *dc, const char *fontstr) {
+	char *def, **missing;
+	int i, n;
+
+	if(!*fontstr)
+		return False;
+	if((dc->font.set = XCreateFontSet(dc->dpy, fontstr, &missing, &n, &def))) {
+		char **names;
+		XFontStruct **xfonts;
+
+		n = XFontsOfFontSet(dc->font.set, &xfonts, &names);
+		for(i = dc->font.ascent = dc->font.descent = 0; i < n; i++) {
+			dc->font.ascent = MAX(dc->font.ascent, xfonts[i]->ascent);
+			dc->font.descent = MAX(dc->font.descent, xfonts[i]->descent);
+		}
+	}
+	else if((dc->font.xfont = XLoadQueryFont(dc->dpy, fontstr))) {
+		dc->font.ascent = dc->font.xfont->ascent;
+		dc->font.descent = dc->font.xfont->descent;
+	}
+	if(missing)
+		XFreeStringList(missing);
+	return (dc->font.set || dc->font.xfont);
+}
+
+void
+mapdc(DC *dc, Window win, unsigned int w, unsigned int h) {
+	XCopyArea(dc->dpy, dc->canvas, win, dc->gc, 0, 0, w, h, 0, 0);
+}
+
+void
+resizedc(DC *dc, unsigned int w, unsigned int h) {
+	if(dc->canvas)
+		XFreePixmap(dc->dpy, dc->canvas);
+	dc->canvas = XCreatePixmap(dc->dpy, DefaultRootWindow(dc->dpy), w, h,
+	                           DefaultDepth(dc->dpy, DefaultScreen(dc->dpy)));
+	dc->x = dc->y = 0;
+	dc->w = w;
+	dc->h = h;
+	dc->invert = False;
+}
+
+int
+textnw(DC *dc, const char *text, size_t len) {
+	if(dc->font.set) {
+		XRectangle r;
+
+		XmbTextExtents(dc->font.set, text, len, NULL, &r);
+		return r.width;
+	}
+	return XTextWidth(dc->font.xfont, text, len);
+}
+
+int
+textw(DC *dc, const char *text) {
+	return textnw(dc, text, strlen(text)) + dc->font.height;
+}
+
+void
+weprintf(const char *fmt, ...) {
+	va_list ap;
+
+	fprintf(stderr, "%s: warning: ", progname);
+	va_start(ap, fmt);
+	vfprintf(stderr, fmt, ap);
+	va_end(ap);
+}
+/* See LICENSE file for copyright and license details. */
+
+#define FG(dc, col)  ((col)[(dc)->invert ? ColBG : ColFG])
+#define BG(dc, col)  ((col)[(dc)->invert ? ColFG : ColBG])
+
+enum { ColBG, ColFG, ColBorder, ColLast };
+
+typedef struct {
+	int x, y, w, h;
+	Bool invert;
+	Display *dpy;
+	GC gc;
+	Pixmap canvas;
+	struct {
+		int ascent;
+		int descent;
+		int height;
+		XFontSet set;
+		XFontStruct *xfont;
+	} font;
+} DC;  /* draw context */
+
+unsigned long getcolor(DC *dc, const char *colstr);
+void drawrect(DC *dc, int x, int y, unsigned int w, unsigned int h, Bool fill, unsigned long color);
+void drawtext(DC *dc, const char *text, unsigned long col[ColLast]);
+void drawtextn(DC *dc, const char *text, size_t n, unsigned long col[ColLast]);
+void initfont(DC *dc, const char *fontstr);
+void freedc(DC *dc);
+DC *initdc(void);
+void mapdc(DC *dc, Window win, unsigned int w, unsigned int h);
+void resizedc(DC *dc, unsigned int w, unsigned int h);
+int textnw(DC *dc, const char *text, size_t len);
+int textw(DC *dc, const char *text);
+void eprintf(const char *fmt, ...);
+void weprintf(const char *fmt, ...);
+
+const char *progname;

File draw.o

Binary file added.